program Lecture2;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Contnrs,
  UString in 'UString.pas',
  UInteger in 'UInteger.pas',
  UDate in 'UDate.pas';

type

  Trans = class
    amount: Integer; // primitivn typ
    date: TDate;     // tda - zaboxovan primitivn typ
  end {Trans};

  Trans2 = class
  private
    amount: Integer; // primitivn typ
    date: TDate;     // tda - zaboxovan primitivn typ
  public
    constructor Create(a: Integer; d: TDate);
    function ToString: String;
  end {Trans2};

  constructor Trans2.Create(a: Integer; d: TDate);
  begin
    amount := a;
    date := d;
  end {Create};

  function Trans2.ToString: String;
  begin
    ToString := IntToStr(amount) + ' on ' + DateTimeToStr(date.TDateTimeValue);
  end {ToString};

var
  a, b: TString;
  v, k: TObjectList;
  t: Trans;
  t2: Trans2;
  i: Integer;
  obj_i: TInteger;

begin
  { TODO -oUser -cConsole Main : Insert code here }

  writeln('1. Variables, References and Objects');
  writeln;

  a := TString.Create('zeeb');
  b := a.ToUpperCase;
  write(b.StringValue); readln;
  a.Free;
  b.Free;

  a := TString.Create('zeeb');
  a.ToUpperCase; // vytvo se nov instance, ale reference na ni se zahod - instanci nebude mon uvolnit
  write(a.StringValue); readln;
  a.Free;

  a := TString.Create('zeeb');
  a := a.ToUpperCase; // vytvo se nov instance a reference na starou instanci se pepe - starou instanci nebude mon uvolnit
  write(a.StringValue); readln;
  a.Free;

  writeln;
  writeln('2. Aliasing, Mutability and Reference Equality');
  writeln;

  v := TObjectList.Create;
  k := v;
  a := TString.Create('zeeb');
  v.Add(a);
  k.Add(a.ToUpperCase);
  write(TString(v.Last).StringValue); readln;
  v.Free;

  v := TObjectList.Create;
  k := v;
  if v = k
    then write('same')
    else write('different');
  readln;
  v.Free;

  v := TObjectList.Create;
  k := TObjectList.Create;
  if v = k
    then write('same')
    else write('different');
  readln;
  v.Free;
  k.Free;

  a := TString.Create('zeeb');
  b := TString.Create('zeeb'); // POZOR: nen to Java, me se chovat jinak
  if a = b
    then write('same')
    else write('different');
  readln;
  a.Free;
  b.Free;

  a := TString.Create('zeeb');
  b := TString.Create(a.ToUpperCase); // vytvo se nov instance, ale reference na ni se zahod - instanci nebude mon uvolnit
  if b.Equals('ZEEB')
    then write('same')
    else write('different');
  readln;
  a.Free;
  b.Free;

  writeln;
  writeln('3. Null References');
  writeln;

  a := nil;
  write(Cardinal(a)); readln; // petypovn odkazu na nezporn cel slo

  try
    a := nil;
    b := a.ToUpperCase;
    write(Cardinal(b)); readln;
  except on e: Exception do
    begin
      write('EXCEPTION RAISED: ' + e.Message); readln;
    end
  end;

  writeln;
  writeln('4. User Defined Classes and Fields');
  writeln;

  i := 5;
  obj_i := TInteger.Create(i);
  write('i = ', i, ', obj_i = ', obj_i.IntegerValue); readln;
  obj_i.Free;

  t := Trans.Create;
  t.amount := 20;
  t.date := TDate.Create;
  write('amount = ', t.amount, ', date = ', DateTimeToStr(t.date.TDateTimeValue)); readln;
  t.date.Free;
  t.Free;

  t2 := Trans2.Create(20, TDate.Create);
  write(t2.ToString); readln;
  t2.date.Free;
  t2.Free;

end.
